aboutsummaryrefslogtreecommitdiffstats
path: root/.config/herbstluftwm
diff options
context:
space:
mode:
authorshmibs <shmibs@gmail.com>2014-02-11 20:47:36 -0700
committershmibs <shmibs@gmail.com>2014-02-11 20:47:36 -0700
commit597d87abf48838c7cbe27d71aa15943ba90840a4 (patch)
treea719e4c200eab0ed0f73bd8ffdeda8d7cd76b5f9 /.config/herbstluftwm
parentae1b43aa519aa400aa6c8aba3b459bba2fc14a7e (diff)
downloaddotfiles-597d87abf48838c7cbe27d71aa15943ba90840a4.tar.gz
AWESOME → HERBSTLUFTWM
i was getting sick of dealing with awesome's steaming pile of lua, and this seems to be a pretty nice alternative =)
Diffstat (limited to '.config/herbstluftwm')
-rwxr-xr-x.config/herbstluftwm/autostart191
-rwxr-xr-x.config/herbstluftwm/panel.sh184
-rwxr-xr-x.config/herbstluftwm/panel.sh.bak184
-rwxr-xr-x.config/herbstluftwm/restartpanels.sh16
-rwxr-xr-x.config/herbstluftwm/tray.sh12
5 files changed, 587 insertions, 0 deletions
diff --git a/.config/herbstluftwm/autostart b/.config/herbstluftwm/autostart
new file mode 100755
index 0000000..1f18392
--- /dev/null
+++ b/.config/herbstluftwm/autostart
@@ -0,0 +1,191 @@
+#!/bin/bash
+
+# define colours
+bg_normal='#2d2d2d'
+fg_normal='#dcdcdc'
+bg_focus='#d64937'
+fg_focus='#fcfcfc'
+
+hc() {
+ herbstclient "$@"
+}
+
+# always start frames max (pt. 1)
+hc set default_frame_layout 2
+
+hc emit_hook reload
+
+xsetroot -solid '#5A8E3A'
+
+# remove all existing keybindings
+hc keyunbind --all
+
+# keybindings
+# if you have a super key you will be much happier with Mod set to Mod4
+#Mod=Mod1 # Use alt as the main modifier
+Mod=Mod4 # Use the super key as the main modifier
+
+hc keybind $Mod-Shift-r reload
+hc keybind $Mod-e close_or_remove
+
+# basic movement
+# focusing clients
+hc keybind $Mod-h focus left
+hc keybind $Mod-j focus down
+hc keybind $Mod-k focus up
+hc keybind $Mod-l focus right
+
+# moving clients
+hc keybind $Mod-Shift-h shift left
+hc keybind $Mod-Shift-j shift down
+hc keybind $Mod-Shift-k shift up
+hc keybind $Mod-Shift-l shift right
+
+# cycle through clients
+hc keybind $Mod-d cycle 1
+hc keybind $Mod-a cycle -1
+
+# splitting frames
+# create an empty frame at the specified direction
+hc keybind $Mod-s chain .-. lock .-. split bottom 0.5 .-. focus -e d .-. unlock
+hc keybind $Mod-v chain .-. lock .-. split right 0.5 .-. focus -e r .-. unlock
+# let the current frame explode into subframes
+hc keybind $Mod-Shift-space split explode
+
+# resizing frames
+resizestep=0.05
+hc keybind $Mod-Control-h resize left +$resizestep
+hc keybind $Mod-Control-j resize down +$resizestep
+hc keybind $Mod-Control-k resize up +$resizestep
+hc keybind $Mod-Control-l resize right +$resizestep
+
+# tags
+tag_names=( {1..5} )
+tag_keys=( {1..5} 0 )
+
+hc rename default "${tag_names[0]}" || true
+for i in ${!tag_names[@]} ; do
+ hc add "${tag_names[$i]}"
+ key="${tag_keys[$i]}"
+ if ! [ -z "$key" ] ; then
+ hc keybind "$Mod-$key" use_index "$i"
+ hc keybind "$Mod-Control-$key" move_index "$i"
+ fi
+done
+
+# always start frames max (pt. 2)
+hc set_layout max
+
+# cycle through tags
+hc keybind $Mod-period use_index +1 --skip-visible
+hc keybind $Mod-comma use_index -1 --skip-visible
+
+# layouting
+hc keybind $Mod-r remove
+hc keybind $Mod-f fullscreen toggle
+hc keybind $Mod-p pseudotile toggle
+
+# mouse
+hc mouseunbind --all
+hc mousebind $Mod-Button1 move
+hc mousebind $Mod-Button2 zoom
+hc mousebind $Mod-Button3 resize
+
+# focus
+hc keybind $Mod-BackSpace cycle_monitor
+hc keybind $Mod-i jumpto urgent
+
+################ launchers ################
+hc keybind XF86PowerOff spawn mate-session-save --shutdown-dialog
+
+# ranger
+hc keybind $Mod-Shift-Control-Return spawn urxvt -e ranger /home/shmibs
+hc keybind $Mod-Shift-Control-b spawn urxvt -e ranger /home/shmibs/backdrops
+hc keybind $Mod-Shift-Control-c spawn urxvt -e ranger /home/shmibs/comics
+hc keybind $Mod-Shift-Control-d spawn urxvt -e ranger /home/shmibs/downloads
+hc keybind $Mod-Shift-Control-s spawn urxvt -e ranger /home/shmibs/desktop
+hc keybind $Mod-Shift-Control-m spawn urxvt -e ranger /home/shmibs/music
+hc keybind $Mod-Shift-Control-g spawn urxvt -e ranger /home/shmibs/games
+hc keybind $Mod-Shift-Control-p spawn urxvt -e ranger /home/shmibs/projects
+hc keybind $Mod-Shift-Control-i spawn urxvt -e ranger /home/shmibs/images
+hc keybind $Mod-Shift-Control-t spawn urxvt -e ranger /home/shmibs/thcool
+hc keybind $Mod-Shift-Control-v spawn urxvt -e ranger /home/shmibs/videos
+
+# spawn
+hc keybind $Mod-Return spawn urxvt
+hc keybind $Mod-Shift-c spawn mate-calc
+hc keybind $Mod-Shift-d spawn ~/games/desura/desura
+hc keybind $Mod-Shift-f spawn firefox
+hc keybind $Mod-Shift-i spawn gimp
+hc keybind $Mod-Shift-m spawn mathematica
+hc keybind $Mod-Shift-o spawn ~/stuffs/tor/start-tor-browser
+hc keybind $Mod-Shift-t spawn transmission-gtk
+hc keybind $Mod-Shift-v spawn urxvt -e vim
+hc keybind $Mod-Shift-w spawn urxvt -e weechat
+
+# banshee
+hc keybind $Mod-Shift-Up spawn banshee --show
+hc keybind $Mod-Shift-Down spawn banshee --hide
+hc keybind $Mod-Left spawn banshee --restart-or-previous
+hc keybind $Mod-Right spawn banshee --next
+hc keybind $Mod-Down spawn banshee --toggle-playing
+
+# dmenu
+hc keybind $Mod-0 spawn dmenu_run -h 18 -nb $bg_normal -nf $fg_normal -sb $bg_focus -sf $fg_focus
+
+############## end launchers ##############
+
+
+# borders
+hc set frame_border_normal_color $bg_normal
+hc set frame_border_active_color $bg_focus
+hc set frame_bg_normal_color $bg_normal
+hc set frame_bg_active_color $bg_focus
+hc set window_border_normal_color $bg_normal
+hc set window_border_active_color $bg_focus
+hc set frame_border_width 2
+hc set frame_border_inner_width 0
+hc set window_border_width 2
+hc set window_border_inner_width 0
+hc set always_show_frame 0
+hc set frame_bg_transparent 1
+hc set frame_normal_opacity 100
+hc set frame_active_opacity 100
+hc set frame_transparent_width 0
+hc set frame_gap 0
+hc set frame_padding 0
+hc set smart_frame_surroundings 1
+hc set smart_window_surroundings 1
+
+# rules
+hc unrule -F
+hc rule focus=on
+# unmanage docs, dropdowns, etc
+hc rule windowtype~'_NET_WM_WINDOW_TYPE_(NOTIFICATION|DOCK)' manage=off
+# set apppropriate things to pseudotile
+hc rule windowtype~'_NET_WM_WINDOW_TYPE_(DIALOG|UTILITY|SPLASH)' pseudotile=on
+hc rule class~'(Mate-calc|Pcsx2)' pseudotile=on
+
+# unlock, just to be sure
+hc unlock
+
+herbstclient set tree_style '╾│ ├└╼─┐'
+
+# do multi monitor setup here, e.g.:
+# hc set_monitors 1280x1024+0+0 1280x1024+1280+0
+# or simply:
+# hc detect_monitors
+
+# find the panel
+panel=~/.config/herbstluftwm/panel.sh
+[ -x "$panel" ] || panel=/etc/xdg/herbstluftwm/panel.sh
+for monitor in $(herbstclient list_monitors | cut -d: -f1) ; do
+ # start it on each monitor
+ "$panel" $monitor &
+done
+
+# add a tray
+tray=~/.config/herbstluftwm/tray.sh
+if [ -x "$tray" ]; then
+ "$tray"
+fi
diff --git a/.config/herbstluftwm/panel.sh b/.config/herbstluftwm/panel.sh
new file mode 100755
index 0000000..5b365af
--- /dev/null
+++ b/.config/herbstluftwm/panel.sh
@@ -0,0 +1,184 @@
+#!/bin/bash
+
+hc() { "${herbstclient_command[@]:-herbstclient}" "$@" ;}
+monitor=${1:-0}
+geometry=( $(herbstclient monitor_rect "$monitor") )
+if [ -z "$geometry" ] ;then
+ echo "Invalid monitor $monitor"
+ exit 1
+fi
+# geometry has the format W H X Y
+x=${geometry[0]}
+y=${geometry[1]}
+panel_width=${geometry[2]}
+panel_height=18
+font="-*-fixed-medium-*-*-*-12-*-*-*-*-*-*-*"
+bgcolor=$(hc get frame_border_normal_color)
+selbg=$(hc get window_border_active_color)
+selfg='#101010'
+
+####
+# Try to find textwidth binary.
+# In e.g. Ubuntu, this is named dzen2-textwidth.
+if which textwidth &> /dev/null ; then
+ textwidth="textwidth";
+elif which dzen2-textwidth &> /dev/null ; then
+ textwidth="dzen2-textwidth";
+else
+ echo "This script requires the textwidth tool of the dzen2 project."
+ exit 1
+fi
+####
+# true if we are using the svn version of dzen2
+# depending on version/distribution, this seems to have version strings like
+# "dzen-" or "dzen-x.x.x-svn"
+if dzen2 -v 2>&1 | head -n 1 | grep -q '^dzen-\([^,]*-svn\|\),'; then
+ dzen2_svn="true"
+else
+ dzen2_svn=""
+fi
+
+if awk -Wv 2>/dev/null | head -1 | grep -q '^mawk'; then
+ # mawk needs "-W interactive" to line-buffer stdout correctly
+ # http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=593504
+ uniq_linebuffered() {
+ awk -W interactive '$0 != l { print ; l=$0 ; fflush(); }' "$@"
+ }
+else
+ # other awk versions (e.g. gawk) issue a warning with "-W interactive", so
+ # we don't want to use it there.
+ uniq_linebuffered() {
+ awk '$0 != l { print ; l=$0 ; fflush(); }' "$@"
+ }
+fi
+
+hc pad $monitor $panel_height
+
+{
+ ### Event generator ###
+ # based on different input data (mpc, date, hlwm hooks, ...) this generates events, formed like this:
+ # <eventname>\t<data> [...]
+ # e.g.
+ # date ^fg(#efefef)18:33^fg(#909090), 2013-10-^fg(#efefef)29
+
+ #mpc idleloop player &
+ while true ; do
+ # "date" output is checked once a second, but an event is only
+ # generated if the output changed compared to the previous run.
+ date +$'date\t^fg(#efefef)%a, %b %d, %H:%M:%S'
+ sleep 1 || break
+ done > >(uniq_linebuffered) &
+ childpid=$!
+ hc --idle
+ kill $childpid
+} 2> /dev/null | {
+ IFS=$'\t' read -ra tags <<< "$(hc tag_status $monitor)"
+ visible=true
+ date=""
+ windowtitle=""
+ while true ; do
+
+ ### Output ###
+ # This part prints dzen data based on the _previous_ data handling run,
+ # and then waits for the next event to happen.
+
+ bordercolor="#26221C"
+ separator="^bg()^fg($selbg)|"
+ # draw tags
+ for i in "${tags[@]}" ; do
+ case ${i:0:1} in
+ '#')
+ echo -n "^bg($selbg)^fg($selfg)"
+ ;;
+ '+')
+ echo -n "^bg(#9CA668)^fg(#141414)"
+ ;;
+ ':')
+ echo -n "^bg()^fg(#ffffff)"
+ ;;
+ '!')
+ echo -n "^bg(#FF0675)^fg(#141414)"
+ ;;
+ *)
+ echo -n "^bg()^fg(#ababab)"
+ ;;
+ esac
+ if [ ! -z "$dzen2_svn" ] ; then
+ # clickable tags if using SVN dzen
+ echo -n "^ca(1,\"${herbstclient_command[@]:-herbstclient}\" "
+ echo -n "focus_monitor \"$monitor\" && "
+ echo -n "\"${herbstclient_command[@]:-herbstclient}\" "
+ echo -n "use \"${i:1}\") ${i:1} ^ca()"
+ else
+ # non-clickable tags if using older dzen
+ echo -n " ${i:1} "
+ fi
+ done
+ echo -n "$separator"
+ echo -n "^bg()^fg() ${windowtitle//^/^^}"
+ # small adjustments
+ right="$separator^bg() $date $separator"
+ right_text_only=$(echo -n "$right" | sed 's.\^[^(]*([^)]*)..g')
+ # get width of right aligned text.. and add some space..
+ width=$($textwidth "$font" "$right_text_only ")
+ echo -n "^pa($(($panel_width - $width)))$right"
+ echo
+
+ ### Data handling ###
+ # This part handles the events generated in the event loop, and sets
+ # internal variables based on them. The event and its arguments are
+ # read into the array cmd, then action is taken depending on the event
+ # name.
+ # "Special" events (quit_panel/togglehidepanel/reload) are also handled
+ # here.
+
+ # wait for next event
+ IFS=$'\t' read -ra cmd || break
+ # find out event origin
+ case "${cmd[0]}" in
+ tag*)
+ #echo "resetting tags" >&2
+ IFS=$'\t' read -ra tags <<< "$(hc tag_status $monitor)"
+ ;;
+ date)
+ #echo "resetting date" >&2
+ date="${cmd[@]:1}"
+ ;;
+ quit_panel)
+ exit
+ ;;
+ togglehidepanel)
+ currentmonidx=$(hc list_monitors | sed -n '/\[FOCUS\]$/s/:.*//p')
+ if [ "${cmd[1]}" -ne "$monitor" ] ; then
+ continue
+ fi
+ if [ "${cmd[1]}" = "current" ] && [ "$currentmonidx" -ne "$monitor" ] ; then
+ continue
+ fi
+ echo "^togglehide()"
+ if $visible ; then
+ visible=false
+ hc pad $monitor 0
+ else
+ visible=true
+ hc pad $monitor $panel_height
+ fi
+ ;;
+ reload)
+ exit
+ ;;
+ focus_changed|window_title_changed)
+ windowtitle="${cmd[@]:2}"
+ ;;
+ #player)
+ # ;;
+ esac
+ done
+
+ ### dzen2 ###
+ # After the data is gathered and processed, the output of the previous block
+ # gets piped to dzen2.
+
+} 2> /dev/null | dzen2 -w $panel_width -x $x -y $y -fn "$font" -h $panel_height \
+ -e 'button3=' \
+ -ta l -bg "$bgcolor" -fg '#efefef'
diff --git a/.config/herbstluftwm/panel.sh.bak b/.config/herbstluftwm/panel.sh.bak
new file mode 100755
index 0000000..8c75b5c
--- /dev/null
+++ b/.config/herbstluftwm/panel.sh.bak
@@ -0,0 +1,184 @@
+#!/bin/bash
+
+hc() { "${herbstclient_command[@]:-herbstclient}" "$@" ;}
+monitor=${1:-0}
+geometry=( $(herbstclient monitor_rect "$monitor") )
+if [ -z "$geometry" ] ;then
+ echo "Invalid monitor $monitor"
+ exit 1
+fi
+# geometry has the format W H X Y
+x=${geometry[0]}
+y=${geometry[1]}
+panel_width=${geometry[2]}
+panel_height=18
+font="-*-fixed-medium-*-*-*-12-*-*-*-*-*-*-*"
+bgcolor=$(hc get frame_border_normal_color)
+selbg=$(hc get window_border_active_color)
+selfg='#101010'
+
+####
+# Try to find textwidth binary.
+# In e.g. Ubuntu, this is named dzen2-textwidth.
+if which textwidth &> /dev/null ; then
+ textwidth="textwidth";
+elif which dzen2-textwidth &> /dev/null ; then
+ textwidth="dzen2-textwidth";
+else
+ echo "This script requires the textwidth tool of the dzen2 project."
+ exit 1
+fi
+####
+# true if we are using the svn version of dzen2
+# depending on version/distribution, this seems to have version strings like
+# "dzen-" or "dzen-x.x.x-svn"
+if dzen2 -v 2>&1 | head -n 1 | grep -q '^dzen-\([^,]*-svn\|\),'; then
+ dzen2_svn="true"
+else
+ dzen2_svn=""
+fi
+
+if awk -Wv 2>/dev/null | head -1 | grep -q '^mawk'; then
+ # mawk needs "-W interactive" to line-buffer stdout correctly
+ # http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=593504
+ uniq_linebuffered() {
+ awk -W interactive '$0 != l { print ; l=$0 ; fflush(); }' "$@"
+ }
+else
+ # other awk versions (e.g. gawk) issue a warning with "-W interactive", so
+ # we don't want to use it there.
+ uniq_linebuffered() {
+ awk '$0 != l { print ; l=$0 ; fflush(); }' "$@"
+ }
+fi
+
+hc pad $monitor $panel_height
+
+{
+ ### Event generator ###
+ # based on different input data (mpc, date, hlwm hooks, ...) this generates events, formed like this:
+ # <eventname>\t<data> [...]
+ # e.g.
+ # date ^fg(#efefef)18:33^fg(#909090), 2013-10-^fg(#efefef)29
+
+ #mpc idleloop player &
+ while true ; do
+ # "date" output is checked once a second, but an event is only
+ # generated if the output changed compared to the previous run.
+ date +$'date\t^fg(#efefef)%H:%M^fg(#909090), %Y-%m-^fg(#efefef)%d'
+ sleep 1 || break
+ done > >(uniq_linebuffered) &
+ childpid=$!
+ hc --idle
+ kill $childpid
+} 2> /dev/null | {
+ IFS=$'\t' read -ra tags <<< "$(hc tag_status $monitor)"
+ visible=true
+ date=""
+ windowtitle=""
+ while true ; do
+
+ ### Output ###
+ # This part prints dzen data based on the _previous_ data handling run,
+ # and then waits for the next event to happen.
+
+ bordercolor="#26221C"
+ separator="^bg()^fg($selbg)|"
+ # draw tags
+ for i in "${tags[@]}" ; do
+ case ${i:0:1} in
+ '#')
+ echo -n "^bg($selbg)^fg($selfg)"
+ ;;
+ '+')
+ echo -n "^bg(#9CA668)^fg(#141414)"
+ ;;
+ ':')
+ echo -n "^bg()^fg(#ffffff)"
+ ;;
+ '!')
+ echo -n "^bg(#FF0675)^fg(#141414)"
+ ;;
+ *)
+ echo -n "^bg()^fg(#ababab)"
+ ;;
+ esac
+ if [ ! -z "$dzen2_svn" ] ; then
+ # clickable tags if using SVN dzen
+ echo -n "^ca(1,\"${herbstclient_command[@]:-herbstclient}\" "
+ echo -n "focus_monitor \"$monitor\" && "
+ echo -n "\"${herbstclient_command[@]:-herbstclient}\" "
+ echo -n "use \"${i:1}\") ${i:1} ^ca()"
+ else
+ # non-clickable tags if using older dzen
+ echo -n " ${i:1} "
+ fi
+ done
+ echo -n "$separator"
+ echo -n "^bg()^fg() ${windowtitle//^/^^}"
+ # small adjustments
+ right="$separator^bg() $date $separator"
+ right_text_only=$(echo -n "$right" | sed 's.\^[^(]*([^)]*)..g')
+ # get width of right aligned text.. and add some space..
+ width=$($textwidth "$font" "$right_text_only ")
+ echo -n "^pa($(($panel_width - $width)))$right"
+ echo
+
+ ### Data handling ###
+ # This part handles the events generated in the event loop, and sets
+ # internal variables based on them. The event and its arguments are
+ # read into the array cmd, then action is taken depending on the event
+ # name.
+ # "Special" events (quit_panel/togglehidepanel/reload) are also handled
+ # here.
+
+ # wait for next event
+ IFS=$'\t' read -ra cmd || break
+ # find out event origin
+ case "${cmd[0]}" in
+ tag*)
+ #echo "resetting tags" >&2
+ IFS=$'\t' read -ra tags <<< "$(hc tag_status $monitor)"
+ ;;
+ date)
+ #echo "resetting date" >&2
+ date="${cmd[@]:1}"
+ ;;
+ quit_panel)
+ exit
+ ;;
+ togglehidepanel)
+ currentmonidx=$(hc list_monitors | sed -n '/\[FOCUS\]$/s/:.*//p')
+ if [ "${cmd[1]}" -ne "$monitor" ] ; then
+ continue
+ fi
+ if [ "${cmd[1]}" = "current" ] && [ "$currentmonidx" -ne "$monitor" ] ; then
+ continue
+ fi
+ echo "^togglehide()"
+ if $visible ; then
+ visible=false
+ hc pad $monitor 0
+ else
+ visible=true
+ hc pad $monitor $panel_height
+ fi
+ ;;
+ reload)
+ exit
+ ;;
+ focus_changed|window_title_changed)
+ windowtitle="${cmd[@]:2}"
+ ;;
+ #player)
+ # ;;
+ esac
+ done
+
+ ### dzen2 ###
+ # After the data is gathered and processed, the output of the previous block
+ # gets piped to dzen2.
+
+} 2> /dev/null | dzen2 -w $panel_width -x $x -y $y -fn "$font" -h $panel_height \
+ -e 'button3=' \
+ -ta l -bg "$bgcolor" -fg '#efefef'
diff --git a/.config/herbstluftwm/restartpanels.sh b/.config/herbstluftwm/restartpanels.sh
new file mode 100755
index 0000000..9d9110c
--- /dev/null
+++ b/.config/herbstluftwm/restartpanels.sh
@@ -0,0 +1,16 @@
+#!/bin/bash
+
+installdir=/
+
+XDG_CONFIG_HOME="${XDG_CONFIG_HOME:-$HOME/.config}"
+defaultpanel="$XDG_CONFIG_HOME/herbstluftwm/panel.sh"
+
+[ -x "$defaultpanel" ] || defaultpanel="$installdir/etc/xdg/herbstluftwm/panel.sh"
+
+panelcmd="${1:-$defaultpanel}"
+
+herbstclient emit_hook quit_panel
+
+for i in $(herbstclient list_monitors | cut -d':' -f1) ; do
+ "$panelcmd" $i &
+done
diff --git a/.config/herbstluftwm/tray.sh b/.config/herbstluftwm/tray.sh
new file mode 100755
index 0000000..7a7ee01
--- /dev/null
+++ b/.config/herbstluftwm/tray.sh
@@ -0,0 +1,12 @@
+#!/bin/bash
+hc() { "${herbstclient_command[@]:-herbstclient}" "$@" ;}
+bgcolor=$(hc get frame_border_normal_color)
+
+run=""
+while [ -z "$run" ]; do
+ sleep .5
+ run=$(ps -e | grep dzen2)
+ echo "$run"
+done
+
+stalonetray -bg "$bgcolor" --window-layer top --geometry 1x1+1752+1 --max-geometry 1752x18 --grow-gravity E -i 16 --kludges force_icons_size